Module modUnits

    Public Const Unit_None As Short = -1
    Public Const Unit_Distance As Short = 0
    Public Const Unit_Velocity As Short = 1
    Public Const Unit_Accel As Short = 2
    Public Const Unit_Jerk As Short = 3
    Public Const Unit_AngularDistance As Short = 4
    Public Const Unit_AngularVelocity As Short = 5
    Public Const Unit_AngularAccel As Short = 6
    Public Const Unit_AngularJerk As Short = 7
    Public Const Unit_Incline As Short = 8
    Public Const Unit_Temp As Short = 9
    Public Const Unit_Elev As Short = 10
    Public Const Unit_Time As Short = 11
    Public Const Unit_Capacitance As Short = 12
    Public Const Unit_Inductance As Short = 13
    Public Const Unit_Lead As Short = 14
    Public Const Unit_Mass As Short = 15
    Public Const Unit_Density As Short = 16
    Public Const Unit_Inertia As Short = 17
    Public Const Unit_Force As Short = 18
    Public Const Unit_ForceConstant As Short = 19
    Public Const Unit_Torque As Short = 20
    Public Const Unit_TorqueConstant As Short = 21
    Public Const Unit_LinearRigidity As Short = 22
    Public Const Unit_TorsionalRigidity As Short = 23
    Public Const Unit_Backlash As Short = 24
    Public Const Unit_Power As Short = 25
    Public Const Unit_EnergyDissipation As Short = 26
    Public Const Unit_Efficiency As Short = 27
    Public Const Unit_Current As Short = 28
    Public Const Unit_Voltage As Short = 29
    Public Const Unit_Energy As Short = 30
    Public Const Unit_Resistance As Short = 31
    Public Const Unit_VoltageConstantLinear As Short = 32
    Public Const Unit_VoltageConstantRotary As Short = 33
    Public Const Unit_DutyCycle As Short = 34
    Public Const Unit_ShaftSpeed As Short = 35
    Public Const Unit_ServiceLife As Short = 36
    Public Const Unit_Length As Short = 37
    Public Const Unit_DutyCycleTime As Short = 38
    Public Const Unit_InverterFrequency As Short = 39

    Public Const NUM_UNIT_TYPES As Short = 40

    Public Structure Units
        Dim Value() As Double
        Dim Display() As String
    End Structure

    Public UnitsUnits(NUM_UNIT_TYPES - 1) As Units
    Public UnitsSetup(NUM_UNIT_TYPES - 1) As Short

    Public Sub SetUnitsArray()
        ' * The value is the primary unit / factor to convert to the secondary unit
        ' * There are 1000mm in 1m
        ' * E.g. 1m / 1000 = 1mm

        ' Distance
        With UnitsUnits(Unit_Distance)
            ReDim .Display(6)
            ReDim .Value(6)

            .Display(0) = "m"
            .Value(0) = 1

            .Display(1) = "mm"
            .Value(1) = 10 ^ 3

            .Display(2) = Chr(181) & "m"
            .Value(2) = 10 ^ 6

            .Display(3) = "km"
            .Value(3) = 10 ^ -3

            .Display(4) = "in"
            .Value(4) = 1 / 0.0254

            .Display(5) = "ft"
            .Value(5) = 1 / (0.0254 * 12)

            .Display(6) = "mile"
            .Value(6) = 0.0006213711922
        End With

        ' Velocity
        With UnitsUnits(Unit_Velocity)
            ReDim .Display(8)
            ReDim .Value(8)

            .Display(0) = "m/s"
            .Value(0) = 1

            .Display(1) = "mm/s"
            .Value(1) = 10 ^ 3

            .Display(2) = "m/min"
            .Value(2) = 60

            .Display(3) = "km/h"
            .Value(3) = 3.6

            .Display(4) = "in/s"
            .Value(4) = 1 / 0.0254

            .Display(5) = "in/min"
            .Value(5) = 1 / 0.0254 * 60

            .Display(6) = "ft/s"
            .Value(6) = 1 / (0.0254 * 12)

            .Display(7) = "ft/min"
            .Value(7) = 1 / (0.0254 * 12) * 60

            .Display(8) = "mile/h"
            .Value(8) = 2.236936292
        End With

        ' Accel
        With UnitsUnits(Unit_Accel)
            ReDim .Display(4)
            ReDim .Value(4)

            .Display(0) = "m/s"
            .Value(0) = 1

            .Display(1) = "mm/s"
            .Value(1) = 1000

            .Display(2) = "in/s"
            .Value(2) = 1 / 0.0254

            .Display(3) = "ft/s"
            .Value(3) = 1 / (0.0254 * 12)

            .Display(4) = "ft/min"
            .Value(4) = 1 / (0.0254 * 12) * 60

        End With

        ' Jerk
        With UnitsUnits(Unit_Jerk)
            ReDim .Display(3)
            ReDim .Value(3)

            .Display(0) = "m/s"
            .Value(0) = 1

            .Display(1) = "mm/s"
            .Value(1) = 1000

            .Display(2) = "in/s"
            .Value(2) = 1 / 0.0254

            .Display(3) = "ft/s"
            .Value(3) = 1 / (0.0254 * 12)

        End With

        ' Angular Distance
        With UnitsUnits(Unit_AngularDistance)
            ReDim .Display(2)
            ReDim .Value(2)

            .Display(0) = ""
            .Value(0) = 1

            .Display(1) = "rad"
            .Value(1) = 1 / 180 * PI

            .Display(2) = "rev"
            .Value(2) = 1 / 360

        End With

        ' Angular Velocity
        With UnitsUnits(Unit_AngularVelocity)
            ReDim .Display(5)
            ReDim .Value(5)

            .Display(0) = "/s"
            .Value(0) = 1

            .Display(1) = "/min"
            .Value(1) = 60

            .Display(2) = "rad/s"
            .Value(2) = 1 / 180 * PI

            .Display(3) = "rad/min"
            .Value(3) = 1 / 180 * PI * 60

            .Display(4) = "rev/s"
            .Value(4) = 1 / 360

            .Display(5) = "rpm"
            .Value(5) = 1 / 360 * 60

        End With

        ' Angular Accel
        With UnitsUnits(Unit_AngularAccel)
            ReDim .Display(5)
            ReDim .Value(5)

            .Display(0) = "/s"
            .Value(0) = 1

            .Display(1) = "/min"
            .Value(1) = 60

            .Display(2) = "rad/s"
            .Value(2) = 1 / 180 * PI

            .Display(3) = "rad/min"
            .Value(3) = 1 / 180 * PI * 60

            .Display(4) = "rev/s"
            .Value(4) = 1 / 360

            .Display(5) = "rev/min"
            .Value(5) = 1 / 360 * 60

        End With

        ' Angular Jerk
        With UnitsUnits(Unit_AngularJerk)
            ReDim .Display(2)
            ReDim .Value(2)

            .Display(0) = "/s"
            .Value(0) = 1

            .Display(1) = "rad/s"
            .Value(1) = 1 / 180 * PI

            .Display(2) = "rev/s"
            .Value(2) = 1 / 360

        End With

        ' Incline
        With UnitsUnits(Unit_Incline)
            ReDim .Display(0)
            ReDim .Value(0)

            .Display(0) = ""
            .Value(0) = 1

        End With

        ' Temperature
        With UnitsUnits(Unit_Temp)
            ReDim .Display(1)
            ReDim .Value(1)

            .Display(0) = "C"
            .Value(0) = 1

            .Display(1) = "F"
            .Value(1) = 5 / 9
        End With

        ' Elevation
        With UnitsUnits(Unit_Elev)
            ReDim .Display(1)
            ReDim .Value(1)

            .Display(0) = "m"
            .Value(0) = 1

            .Display(1) = "ft"
            .Value(1) = 1 / (0.0254 * 12)
        End With

        ' Time
        With UnitsUnits(Unit_Time)
            ReDim .Display(4)
            ReDim .Value(4)

            .Display(0) = "s"
            .Value(0) = 1

            .Display(1) = "ms"
            .Value(1) = 10 ^ 3

            .Display(2) = Chr(181) & "s"
            .Value(2) = 10 ^ 6

            .Display(3) = "min"
            .Value(3) = 1 / 60

            .Display(4) = "h"
            .Value(4) = 1 / 60 / 60
        End With

        ' Capacitance
        With UnitsUnits(Unit_Capacitance)
            ReDim .Display(2)
            ReDim .Value(2)

            .Display(0) = "F"
            .Value(0) = 1

            .Display(1) = "mF"
            .Value(1) = 1000

            .Display(2) = "F"
            .Value(2) = 1000000
        End With

        ' Inductance
        With UnitsUnits(Unit_Inductance)
            ReDim .Display(2)
            ReDim .Value(2)

            .Display(0) = "H"
            .Value(0) = 1

            .Display(1) = "mH"
            .Value(1) = 1000

            .Display(2) = "H"
            .Value(2) = 1000000
        End With

        ' Lead
        With UnitsUnits(Unit_Lead)
            ' Notes:
            ' 1. If changes made here, make appropriate changes in ConvertLeadUnits function
            ' 2. Each unit must contain 'rev' as its display text
            ReDim .Display(3)
            ReDim .Value(3)

            .Display(0) = "rev/m"
            .Value(0) = 1

            .Display(1) = "mm/rev"
            .Value(1) = 1000

            .Display(2) = "rev/in"
            .Value(2) = 1 / 0.0254

            .Display(3) = "in/rev"
            .Value(3) = 1 / 0.0254

        End With

        ' Mass
        With UnitsUnits(Unit_Mass)
            ReDim .Display(3)
            ReDim .Value(3)

            .Display(0) = "kg"
            .Value(0) = 1

            .Display(1) = "g"
            .Value(1) = 1000

            .Display(2) = "lb"
            .Value(2) = 2.20462

            .Display(3) = "oz"
            .Value(3) = 35.27392

        End With

        ' Density
        With UnitsUnits(Unit_Density)
            ReDim .Display(3)
            ReDim .Value(3)

            .Display(0) = "kg/m"
            .Value(0) = 1

            .Display(1) = "g/cm"
            .Value(1) = 0.001

            .Display(2) = "lb/in"
            .Value(2) = 0.000036127292

            .Display(3) = "oz/in"
            .Value(3) = 0.00062992125984252

        End With

        ' Inertia
        With UnitsUnits(Unit_Inertia)
            ReDim .Display(4)
            ReDim .Value(4)

            .Display(0) = "kg-m"
            .Value(0) = 1

            .Display(1) = "kg-cm"
            .Value(1) = 10000

            .Display(2) = "lb-ft-s"
            .Value(2) = 0.737562

            .Display(3) = "lb-in-s"
            .Value(3) = 8.8527

            .Display(4) = "oz-in-s"
            .Value(4) = 141.643

        End With

        ' Force
        With UnitsUnits(Unit_Force)
            ReDim .Display(3)
            ReDim .Value(3)

            .Display(0) = "N"
            .Value(0) = 1

            .Display(1) = "kN"
            .Value(1) = 0.001

            .Display(2) = "lb"
            .Value(2) = 0.2248089431

            .Display(3) = "oz"
            .Value(3) = 3.59694309

        End With

        ' Torque
        With UnitsUnits(Unit_Torque)
            ReDim .Display(4)
            ReDim .Value(4)

            .Display(0) = "Nm"
            .Value(0) = 1

            .Display(1) = "kN-m"
            .Value(1) = 0.001

            .Display(2) = "lb-ft"
            .Value(2) = 0.737561033

            .Display(3) = "lb-in"
            .Value(3) = 8.85075

            .Display(4) = "oz-in"
            .Value(4) = 141.611646

        End With

        ' Force Constant
        With UnitsUnits(Unit_ForceConstant)
            ReDim .Display(3)
            ReDim .Value(3)

            .Display(0) = "N/A"
            .Value(0) = 1

            .Display(1) = "kN/A"
            .Value(1) = 0.001

            .Display(2) = "lb/A"
            .Value(2) = 0.2248089431

            .Display(3) = "oz/A"
            .Value(3) = 3.59694309

        End With

        ' Torque Constant
        With UnitsUnits(Unit_TorqueConstant)
            ReDim .Display(3)
            ReDim .Value(3)

            .Display(0) = "Nm/A"
            .Value(0) = 1

            .Display(1) = "lb-ft/A"
            .Value(1) = 0.737561033

            .Display(2) = "lb-in/A"
            .Value(2) = 8.85075

            .Display(3) = "oz-in/A"
            .Value(3) = 141.611646

        End With

        ' Linear Rigidity
        With UnitsUnits(Unit_LinearRigidity)
            ReDim .Display(4)
            ReDim .Value(4)

            .Display(0) = "N/m"
            .Value(0) = 1

            .Display(1) = "N/m"
            .Value(1) = 10 ^ -6

            .Display(2) = "kN/m"
            .Value(2) = 10 ^ -9

            .Display(3) = "lb/ft"
            .Value(3) = 0.0685307

            .Display(4) = "lb/in"
            .Value(4) = 0.00571102

        End With

        ' Torsional Rigidity
        With UnitsUnits(Unit_TorsionalRigidity)
            ReDim .Display(1)
            ReDim .Value(1)

            .Display(0) = "Nm/arcmin"
            .Value(0) = 1

            .Display(1) = "lb-in/arcmin"
            .Value(1) = 8.85075

        End With

        ' Lead
        With UnitsUnits(Unit_Backlash)
            ReDim .Display(3)
            ReDim .Value(3)

            .Display(0) = "arcmin"
            .Value(0) = 1

            .Display(1) = ""
            .Value(1) = 1 / 60

            .Display(2) = "rad"
            .Value(2) = 1 / 60 / 360 * 2 * PI

            .Display(3) = "rev"
            .Value(3) = 1 / 60 / 360

        End With

        ' Power
        With UnitsUnits(Unit_Power)
            ReDim .Display(2)
            ReDim .Value(2)

            .Display(0) = "W"
            .Value(0) = 1

            .Display(1) = "kW"
            .Value(1) = 0.001

            .Display(2) = "HP"
            .Value(2) = 1 / 745.6998716

        End With

        ' Energy Dissipation
        With UnitsUnits(Unit_EnergyDissipation)
            ReDim .Display(2)
            ReDim .Value(2)

            .Display(0) = "Ws"
            .Value(0) = 1

            .Display(1) = "kWs"
            .Value(1) = 0.001

            .Display(2) = "HPs"
            .Value(2) = 1 / 745.6998716

        End With

        ' Efficiency
        With UnitsUnits(Unit_Efficiency)
            ReDim .Display(1)
            ReDim .Value(1)

            .Display(0) = "1" ' Used "1" instead of "-" since a line replaces "-" in popup menus for units
            .Value(0) = 1

            .Display(1) = "%"
            .Value(1) = 100

        End With

        ' Current
        With UnitsUnits(Unit_Current)
            ReDim .Display(0)
            ReDim .Value(0)

            .Display(0) = "A"
            .Value(0) = 1

        End With

        ' Voltage
        With UnitsUnits(Unit_Voltage)
            ReDim .Display(0)
            ReDim .Value(0)

            .Display(0) = "V"
            .Value(0) = 1

        End With

        ' Energy
        With UnitsUnits(Unit_Energy)
            ReDim .Display(0)
            ReDim .Value(0)

            .Display(0) = "J"
            .Value(0) = 1

        End With

        ' Resistance
        With UnitsUnits(Unit_Resistance)
            ReDim .Display(0)
            ReDim .Value(0)

            .Display(0) = "Ohms"
            .Value(0) = 1

        End With

        ' Voltage Constant Linear
        With UnitsUnits(Unit_VoltageConstantLinear)
            ReDim .Display(0)
            ReDim .Value(0)

            .Display(0) = "Vs/m"
            .Value(0) = 1

        End With

        ' Voltage Constant Rotary
        With UnitsUnits(Unit_VoltageConstantRotary)
            ReDim .Display(0)
            ReDim .Value(0)

            .Display(0) = "V/1000/min"
            .Value(0) = 1

        End With

        ' Duty Cycle
        With UnitsUnits(Unit_DutyCycle)
            ReDim .Display(0)
            ReDim .Value(0)

            .Display(0) = "%"
            .Value(0) = 1

        End With

        ' Shaft Speed
        With UnitsUnits(Unit_ShaftSpeed)
            ReDim .Display(5)
            ReDim .Value(5)

            .Display(0) = "/s"
            .Value(0) = 360 / 60

            .Display(1) = "/min"
            .Value(1) = 360

            .Display(2) = "rad/s"
            .Value(2) = 2 * PI / 60

            .Display(3) = "rad/min"
            .Value(3) = 2 * PI

            .Display(4) = "rev/s"
            .Value(4) = 1 / 60

            .Display(5) = "rpm"
            .Value(5) = 1

        End With

        ' Service Life
        With UnitsUnits(Unit_ServiceLife)
            ReDim .Display(0)
            ReDim .Value(0)

            .Display(0) = "h"
            .Value(0) = 1

        End With

        ' Length
        With UnitsUnits(Unit_Length)
            ReDim .Display(4)
            ReDim .Value(4)

            .Display(0) = "m"
            .Value(0) = 1

            .Display(1) = "mm"
            .Value(1) = 10 ^ 3

            .Display(2) = Chr(181) & "m"
            .Value(2) = 10 ^ 6

            .Display(3) = "in"
            .Value(3) = 1 / 0.0254

            .Display(4) = "ft"
            .Value(4) = 1 / (0.0254 * 12)

        End With

        ' Duty Cycle Time
        With UnitsUnits(Unit_DutyCycleTime)
            ReDim .Display(0)
            ReDim .Value(0)

            .Display(0) = "min"
            .Value(0) = 1

        End With

        ' Inverter Frequency
        With UnitsUnits(Unit_InverterFrequency)
            ReDim .Display(0)
            ReDim .Value(0)

            .Display(0) = "kHz"
            .Value(0) = 1

        End With

        ' Consider adding the following
        ' Linear Density: kg/m, lb/in

    End Sub

    Public Function ConvertTempUnits(ByRef dValue As Double, ByRef FromUnits As String, ByRef ToUnits As String) As Double
        ' When converting temp, actual value is returned, not a factor
        If FromUnits = ToUnits Then
            ' Celsius
            ConvertTempUnits = dValue
        Else
            If FromUnits = "C" And ToUnits = "F" Then
                ' Celsius to Fahrenheit
                ConvertTempUnits = 9 / 5 * dValue + 32
            Else
                ' Fahrenheit to Celsius
                ConvertTempUnits = 5 / 9 * (dValue - 32)
            End If
        End If
    End Function
End Module